//+------------------------------------------------------------------+
//|                                                  Butterworth.mq4 |
//|                       Public Domain, Ralph Ronnquist and JustiZe |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Public Domain, Ralph Ronnquist and JustiZe"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Red
#property indicator_color3 Red

extern double    A=0.1367;
extern double    B=-0.7265;
extern double    F=1;
extern double    G=1;

double output_close[];
double output_high[];
double output_low[];
double output_noise[];

int init()
{
    int index;
    
    index = 0;
    SetIndexStyle( index, DRAW_LINE );
    SetIndexBuffer( index, output_close );
    SetIndexLabel( index, "output" );
    SetIndexStyle( index + 1, DRAW_LINE );
    SetIndexBuffer( index + 1, output_high );
    SetIndexLabel( index + 1, "output2" );
    SetIndexStyle( index + 2, DRAW_LINE );
    SetIndexBuffer( index + 2, output_low );
    SetIndexLabel( index + 2, "output3" );
    return(0);
}

int deinit()
{
    return(0);
}

int start()
{
    for ( int bar = Bars - IndicatorCounted(); bar >= 0; bar-- ) {
        indicate( bar );
    }
    return(0);
}

void indicate(int bar)
{
    if ( bar + 1 >= Bars ) {
        output_close[ bar ] = A * Close[ bar ];
        output_high[ bar ]  = A * High[ bar ];
        output_low[ bar ]   = A * Low[ bar ];
        output_noise[ bar ] = F * Close[ bar];
    } else {
        output_close[ bar ] = A * Close[ bar ] + A * Close[ bar+1 ] - B * output_close[ bar+1 ];
        output_high[ bar ]  = A * High[ bar ]  + A * High[ bar+1 ]  - B * output_high[ bar+1 ];
        output_low[ bar ]   = A *  Low[ bar ]  + A * Low[ bar+1 ]   - B * output_low[ bar+1 ];
        output_noise[ bar ] = F * Close[ bar]  + F * Close[ bar+1 ] - G * output_noise[ bar+1 ];
    }
}
//+------------------------------------------------------------------+